routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/*Route::get('/', function () {
    return view('dashboard');
});*/

Auth::routes();


Route::middleware('auth')->group(function () {
    Route::get('/', 'HomeController@index')->name('dashboard');
    Route::get('userDetail/{id}', 'HomeController@userDetail')->name('userDetail');
    Route::get('userDetail/{user_id}/trip/{trip_id}', 'UserTripController@show')->name('user_trip_detail');
    Route::get('/logout', 'HomeController@logout');
    Route::get('/profile', function ()
    {
        return view('pages.user.profile');

    })->name('profile');

    Route::get('/change-password', function ()
    {
        return view('pages.user.change_password');

    })->name('change-password');
    Route::delete('attachment/{id}', 'Admin\GeneralSettingController@delete_attachment')->name('delete_attachment');
    Route::post('/profile', 'Admin\GeneralSettingController@updateProfile')->name('update-profile');
    Route::post('/change-password', 'Admin\GeneralSettingController@updatePassword')->name('update-change-password');

    Route::get('notifications', 'Admin\GeneralSettingController@index')->name('notification-all');
    Route::get('notifications/{id}', 'Admin\GeneralSettingController@show')->name('notification.show');
    Route::get('notifications/read/{id}', 'Admin\GeneralSettingController@edit')->name('notification.read');

    Route::resource('users', 'Admin\UserController');
    Route::put('users/status/{id}', 'Admin\UserController@updateStatus')->name('users.status');
    Route::get('driver/requests', 'Admin\DriverController@Driverrequests')->name('driver.requested');
    Route::get('driver/requests/{id}', 'Admin\DriverController@DriverrequestsUser')->name('driver.requested.id');
    Route::get('driver/accept/{id}', 'Admin\DriverController@DriverAccept')->name('driver.accept');
    Route::get('driver/reject/{id}', 'Admin\DriverController@DriverReject')->name('driver.reject');
    Route::resource('driver', 'Admin\DriverController');
    Route::resource('brands', 'Admin\CarBrandController');
    Route::resource('models', 'Admin\CarModelController');
    Route::resource('faqs', 'Admin\FaqsController');
    Route::resource('generalsetting', 'Admin\GeneralSettingController');
    Route::resource('appbanner', 'Admin\AppBannerController');
    Route::resource('promocodes', 'Admin\PromocodeController');
    Route::resource('user-trips', 'Admin\UserTripController');
    Route::resource('payments', 'Admin\PaymentController');
    Route::resource('user-complaints', 'Admin\ComplaintController');
    Route::resource('custom-notification', 'Admin\CustomEmailController');
    Route::resource('rental-cars', 'Admin\RentalCarController');
    Route::resource('booking-cars', 'Admin\BookedRentalCarController');
    Route::get('booking-cars/{status}/{id}', 'Admin\BookedRentalCarController@updateStatus');
    Route::get('booking-cars/status/{status}/{id}', 'Admin\BookedRentalCarController@updatebookingStatus');
    Route::put('banner/status/{id}', 'Admin\AppBannerController@updateStatus')->name('banner.status');
});

Route::get('storage/app/{dir}/{filename}', function ($dir, $filename) {
    $path = storage_path('app/' . $dir . '/' . $filename);
    /*
    if (!File::exists($path)) {
        abort(404);
    }

    $file = File::get($path);
    $type = File::mimeType($path);

    $response = Response::make($file, 200);
    $response->header("Content-Type", $type);
    */
    return response()->file($path);

});

use App\Models\User;
use App\Notifications\ChatMessage;

Route::get('/test/{email}', function ($email) {
    $receiver = User::where('email', $email)->first();
    $receiver->notify(new ChatMessage($receiver, 'Test notification'));
});

// use App\Events\LocateDriver;
// use DB;

// Route::get('/socket-test', function () {
//     $data = [
//         'user_id' => 11,
//         'latitude' => 12.45,
//         'longitude' => 12.45,
//     ];
//     event(new LocateDriver($data));
//     return "ok";
// });
// Route::get('/truncate', function () {
//     DB::statement("SET SQL_SAFE_UPDATES = 0;");
//     DB::table('users')->where('id','!=',382)->delete();
//     return "ok";
//     DB::table('user_addresses')->truncate();
//     DB::table('user_trips')->truncate();
//     DB::table('attachments')->truncate();
// });

app/Models/RentalCar.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class RentalCar extends Model
{
    use HasFactory, SoftDeletes;

    protected $fillable = [
        'name',
        'model',
        'year',
        'color',
        'color_code',
        'description',
        'price_per_day',
        'price_per_hour',
        'passengers',
        'doors',
        'horse_power',
        'speed',
        'fuel_kit',
        'transmission_type',
        'status',
    ];
    protected $appends = ['avg_rating','attachments'];
    public function bookings()
    {
        return $this->hasMany(BookRentalCar::class)->latest();
    }

    public function attachments()
    {
        return $this->morphMany(Attachment::class, 'attachable')->latest();
    }
    public function getAttachmentsAttribute()
    {
        return $this->attachments()->get();
    }
    public function ratings()
    {
        return $this->hasMany(ReviewsAndRating::class, 'rental_car_id','id');
    }

    public function avg_rating()
    {
        return $this->ratings()->avg('rating');
    }

    public function getAvgRatingAttribute()
    {
        return $this->avg_rating();
    }
    public function getRatingsAttribute()
    {
        return $this->ratings();
    }
}

app/Http/Controllers/Admin/RentalCarController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\RentalCar;
use App\DataTables\CarRentalDataTable;
use App\Helpers\Helper;

class RentalCarController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(CarRentalDataTable $datatable)
    {
        return $datatable->render('pages.rental_cars.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.rental_cars.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required',
            'model' => 'required',
            'year' => 'required|date_format:Y',
            'transmission_type' => 'required',
            'color_code' => 'required',
            'price_per_day' => 'required|numeric',
            'passengers' => 'required|numeric',
            'doors' => 'required|numeric',
            'horse_power' => 'required|numeric',
            'speed' => 'required|numeric',
            'fuel_kit' => 'required',
            'description' => 'nullable',
        ]);

        try {
            $car = RentalCar::create($request->except('files'));
            if($request->has('files'))
            {
                $request->validate([
                    'files.*' => 'image'
                ]);
                $files = $request->file('files');
                foreach($files as $file)
                {
                    $request['image'] = $file;
                // dd($request->all());
                    $file_path = Helper::file_upload_with_array($request->all(), 'image', 'Rental_Car');
                    $attachment['file_path'] = $file_path;
                    $attachment['type'] = 'rental_cars';
                    $car->attachments()->create($attachment);
                }
            }
        } catch (Exception $e) {
            return back()->with('error', 'Something went Wrong...! '.$e->getMessage());
            // dd($e->getMessage());
        }

        return back()->with('insert', 'Car Added Successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $car = RentalCar::with(['attachments'])->find($id);

        if(!$car) abort(404);

        return view('pages.rental_cars.show', compact('car'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $car = RentalCar::with(['attachments'])->find($id);

        if(!$car) abort(404);

        return view('pages.rental_cars.create', compact('car'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $car = RentalCar::find($id);
        if(!$car) abort(404);
        // dd($request->all());
        $request->validate([
            'name' => 'required',
            'model' => 'required',
            'year' => 'required|date_format:Y',
            'transmission_type' => 'required',
            'color_code' => 'required',
            'price_per_day' => 'required|numeric',
            'passengers' => 'required|numeric',
            'doors' => 'required|numeric',
            'horse_power' => 'required|numeric',
            'speed' => 'required|numeric',
            'fuel_kit' => 'required',
            'description' => 'nullable',

        ]);

        $car->update($request->all());
        // dd($car);
        if($request->has('files'))
        {
            $request->validate([
                'files.*' => 'image'
            ]);
         // $attachments = $car->attachments;
            // foreach($attachments as $attachment)
            // {
            //     $attch = Helper::file_delete($attachment->file_path);
            //     $attachment->delete();
            // }
            $files = $request->file('files');
            foreach($files as $index => $file)
            {
                $request['image'] = $file;
                // dd($request->all());
                $file_path = Helper::file_upload_with_array($request->all(), 'image', 'Rental_Car');
                $attachment['file_path'] = $file_path;
                $attachment['type'] = 'rental_cars';
                $car->attachments()->create($attachment);
            }
        }

        return back()->with('insert', 'Car Updated Successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $car = RentalCar::find($id);

        if(!$car) abort(404);

        $car->delete();

        return redirect()->route('rental-cars.index')->with('insert', 'Car Deleted Successfully');
    }
}

resources/views/pages/rental_cars/action.blade.php
<a href="{{ route('rental-cars.show', $id) }}" class="btn btn-warning"><i class="fa fa-eye"></i></a>
<a href="{{ route('rental-cars.edit', $id) }}" class="btn btn-primary"><i class="fa fa-pencil"></i></a>
<form action="{{ route('rental-cars.destroy', $id) }}" method="post">
    @csrf
    @method('DELETE')
    <button type="submit" class="btn btn-danger"><i class="fa fa-trash"></i></button>
</form>

resources/views/pages/rental_cars/create.blade.php
@extends('layouts.default')
@section('title', isset($car)?'Edit ':'Add '.'Car')
@section('content')
    <div class="content-wrapper">
        <div class="row">
            <div class="col-12 grid-margin stretch-card">
                <div class="card">
                    <div class="card-body">
                        <h4 class="card-title">{{ isset($car)?'Edit ':'Add ' }}Car</h4>
                        <form class="forms-sample" action="{{ isset($car)?route('rental-cars.update', $car->id):route('rental-cars.store') }}" method="POST" enctype="multipart/form-data">
                            @csrf
                            @isset($car)
                                @method('PUT')
                            @endisset
                            <div class="form-group">
                                <label for="name">Name:</label>
                                <input type="text" class="form-control" name="name" id="name" placeholder="Name" value="{{ old('name', $car->name??'') }}">
                            </div>
                            @error('name')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror
                            <div class="form-group">
                                <label for="model">Model</label>
                                <input type="text" class="form-control" name="model" id="model" placeholder="Model" value="{{ old('model', $car->model??'') }}">
                            </div>
                            @error('model')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror
                            <div class="form-group">
                                <label for="year">Year</label>
                                <input type="number" class="form-control" name="year" id="year" placeholder="Year" value="{{ old('year', $car->year??'') }}">
                            </div>
                            @error('year')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror
                            <div class="form-group">
                                <label for="color_code">Color</label>
                                <input type="color" class="form-control" name="color_code" id="color_code" placeholder="Color" value="{{ old('color_code', $car->color_code??'') }}">
                            </div>
                            @error('color_code')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror
                            <div class="form-group">
                                <label for="price_per_day">Price</label>
                                <input type="number" class="form-control" name="price_per_day" step="any" id="price_per_day" placeholder="Price per Day" value="{{ old('price_per_day', $car->price_per_day??'') }}">
                            </div>
                            @error('price_per_day')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror
                            <div class="form-group">
                                <label for="passengers">No. Passengers</label>
                                <input type="number" class="form-control" id="passengers" name="passengers" placeholder="Number of Passengers" value="{{ old('passengers', $car->passengers??'') }}">
                            </div>
                            @error('passengers')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror
                            <div class="form-group">
                                <label for="doors">No. Doors</label>
                                <input type="number" class="form-control" id="doors" name="doors" placeholder="Number of Doors" value="{{ old('doors', $car->doors??'') }}">
                            </div>
                            @error('doors')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror

                            <div class="form-group">
                                <label for="horse_power">Horse Power</label>
                                <input type="number" class="form-control" id="horse_power" name="horse_power" placeholder="Horse Power" value="{{ old('horse_power', $car->horse_power??'') }}">
                            </div>
                            @error('horse_power')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror

                            <div class="form-group">
                                <label for="speed">Speed KM/H</label>
                                <input type="number" class="form-control" id="speed" name="speed" placeholder="Speed KM/H" value="{{ old('speed', $car->speed??'') }}">
                            </div>
                            @error('speed')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror

                            <div class="form-group">
                                <label for="fuel_kit">Fuel KIT</label>
                                <select class="form-control" name="fuel_kit" id="fuel_kit" required>
                                    <option value=""></option>
                                    <option value="petrol" @selected(old('fuel_kit', $car->fuel_kit??'')=='petrol')>Petrol</option>
                                    <option value="gas" @selected(old('fuel_kit', $car->fuel_kit??'')=='gas')>GAS</option>
                                </select>
                            </div>
                            @error('fuel_kit')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror
                            <div class="form-group">
                                <label for="transmission_type">Transmission Type</label>
                                <select class="form-control" name="transmission_type" id="transmission_type" required>
                                    <option value=""></option>
                                    <option value="automatic" @selected(old('transmission_type', $car->transmission_type??'')=='automatic')>Automatic</option>
                                    <option value="manual" @selected(old('transmission_type', $car->transmission_type??'')=='manual')>Manual</option>
                                </select>
                            </div>
                            @error('transmission_type')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror
                            <div class="form-group">
                                <label>Car Images</label>
                                <div class="input-group col-xs-12">
                                    <input type="file" name="files[]" class="form-control file-upload-info" placeholder="Upload Image" multiple>
                                </div>
                            </div>
                            @error('files')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror
                            <div class="form-group">
                                <label for="description">Description</label>
                                <textarea name="description" cols="12" rows="12" id="description" class="form-control">{{ old('description', $car->description??'') }}</textarea>
                            </div>
                            @error('description')
                                <div class="alert alert-danger">{{ $message }}</div>
                            @enderror
                            {{-- <div class="form-group">
                                <label>License Front</label>
                                <div class="input-group col-xs-12">
                                    <input type="file" name="license_front" class="form-control file-upload-info"
                                        placeholder="Upload Image">
                                </div>
                            </div>
                            <div class="form-group">
                                <label>License Back</label>
                                <div class="input-group col-xs-12">
                                    <input type="file" name="license_back" class="form-control file-upload-info"
                                        placeholder="Upload Image">
                                </div>
                            </div> --}}

                            <button type="submit" class="btn btn-primary me-2">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/pages/rental_cars/index.blade.php
@extends('layouts.default')
@section('title', 'Rental Car')
@section('content')
<div class="content-wrapper">
    <div class="row">
      <div class="col-lg-12 grid-margin stretch-card">
        <div class="card">
          <div class="card-body">
            <h4 class="card-title">Rental Car</h4>
            <div class="table-responsive">
                {{ $dataTable->table() }}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  @push('scripts')
    {{ $dataTable->scripts(attributes: ['type' => 'module']) }}
@endpush
@endsection

resources/views/pages/rental_cars/show.blade.php
@extends('layouts.default')
@section('title', "View Rental Car Detail")
@section('content')
@push('css_lib')
<style>
    table td{
        background: white;
    }
    .carousel-item img {
        height: 450px !important;
        object-fit: cover;
        object-position: center;
    }
    .carousel-item:after {
        content: "";
        position: absolute;
        left: 0;
        right: 0;
        top: 0;
        bottom: 0;
        background: rgba(0,0,0,0.3);
    }
    .carousel-caption {
        z-index: 1;
    }
</style>
@endpush
    <div class="content-wrapper">
        <div class="row">
            <div class="col-lg-12 grid-margin stretch-card">
                <div class="card">
                    <div class="card-body">
                        <h4 class="card-title">{{ $car->name }}</h4>
                        <div class="card">
                            <div class="card-body">
                                <div id="carouselExampleIndicators" class="carousel slide carousel-fade carousel-top hoverable" data-ride="carousel">
                                    <ol class="carousel-indicators">
                                      <li data-target="#carouselExampleIndicators" data-slide-to="0" class="active"></li>
                                      <li data-target="#carouselExampleIndicators" data-slide-to="1"></li>
                                      <li data-target="#carouselExampleIndicators" data-slide-to="2"></li>
                                    </ol>
                                    <div class="carousel-inner">
                                        @foreach ($car->attachments as $index => $attachment)
                                        <div class="carousel-item {{ $index==0?'active':'' }}">
                                          <img class="d-block w-100" src="{{ asset($attachment->file_path) }}" alt="{{$index}} slide">
                                          <div class="carousel-caption d-none d-md-block">
                                            <h5>#{{$index+1}} Picture</h5>
                                            {{-- <p>Hello</p> --}}
                                            <form action="{{ route('delete_attachment', $attachment->id) }}" method="post">
                                                @csrf
                                                @method('DELETE')
                                                <button class="btn btn-danger">Delete Image</button>
                                            </form>
                                          </div>
                                        </div>
                                        @endforeach
                                    </div>
                                    @if (count($car->attachments) > 1)
                                        <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
                                        <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                                        <span class="sr-only">Previous</span>
                                        </a>
                                        <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
                                        <span class="carousel-control-next-icon" aria-hidden="true"></span>
                                        <span class="sr-only">Next</span>
                                        </a>
                                    @endif
                                  </div>
                            </div>
                        </div>
                        <table class="mt-3 table table-bordered table-secondary">
                            <thead>
                                <tr>
                                    <th>Card Id</th>
                                    <td>{{ $car->id }}</td>
                                </tr>
                                <tr>
                                    <th>Card Name</th>
                                    <td>{{ $car->name }}</td>
                                </tr>
                                <tr>
                                    <th>Card Model</th>
                                    <td>{{ $car->model }}</td>
                                </tr>
                                <tr>
                                    <th>Year</th>
                                    <td>{{ $car->year }}</td>
                                </tr>
                                <tr>
                                    <th>Color</th>
                                    <td>{{ $car->color.' '.$car->color_code }}</td>
                                </tr>
                                <tr>
                                    <th>Price per Day</th>
                                    <td>{{ $car->price_per_day }}</td>
                                </tr>
                                <tr>
                                    <th>No. Passengers</th>
                                    <td>{{ $car->name }}</td>
                                </tr>
                                <tr>
                                    <th>No. Doors</th>
                                    <td>{{ $car->doors }}</td>
                                </tr>
                                <tr>
                                    <th>Horse Power</th>
                                    <td>{{ $car->horse_power }}</td>
                                </tr>
                                <tr>
                                    <th>Speed</th>
                                    <td>{{ $car->speed }} KM/H</td>
                                </tr>
                                <tr>
                                    <th>Fuel Kit</th>
                                    <td>{{ $car->fuel_kit }}</td>
                                </tr>
                                <tr>
                                    <th>Transmission Type</th>
                                    <td>{{ $car->transmission_type }}</td>
                                </tr>
                                <tr>
                                    <th>Description</th>
                                    <td>{!! $car->description !!}</td>
                                </tr>
                            </thead>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
@push('scripts')
<script>
    $('.carousel').carousel()
</script>
@endpush
@endsection